<script>
import TaxRateAction from '../../../components/settings/TaxRateAction.vue'

export default {
  components: {
    TaxRateAction
  }
}
</script>

<script setup>
const router = useRouter()
const tabs = useTabs()

definePageMeta({
  middleware: ['auth', 'org']
})

const isDeletable = ref(false)
const searchQuery = ref('')
const selectedRows = ref([])

const { data, pending, error, refresh } = await useFetch('/api/settings/tax-rates', {
  headers: useRequestHeaders(['cookie'])
})

const rowData = computed(() => data.value?.records?.map(item => {
  return {
    id: item.id,
    uid: item.uid,
    name: item.Name,
    description: item.Description,
    isActive: item.IsActive,
    isDefault: item.IsDefault,
    isDocumentLevel: item.IsDocumentLevel,
    isSummary: item.IsSummary,
    isTaxExempt: item.IsTaxExempt,
    isSalesTax: item.IsSalesTax,
    validFrom: item.ValidFrom,
    rate: item.Rate,
    requiresTaxCertificate: item.RequiresTaxCertificate,
    taxIndicator: item.TaxIndicator,
    countryGroup: item.C_CountryGroup_ID?.identifier || '',
    countryGroupId: item.C_CountryGroup_ID?.id || '',
    country: item.C_Country_ID?.identifier || '',
    countryId: item.C_Country_ID?.id || '',
    region: item.C_Region_ID?.identifier || '',
    regionId: item.C_Region_ID?.id || '',
    toCountryGroup: item.To_CountryGroup_ID?.identifier || '',
    toCountryGroupId: item.To_CountryGroup_ID?.id || '',
    toCountry: item.To_Country_ID?.identifier || '',
    toCountryId: item.To_Country_ID?.id || '',
    toRegion: item.To_Region_ID?.identifier || '',
    toRegionId: item.To_Region_ID?.id || '',
    taxCategory: item.C_TaxCategory_ID?.identifier || '',
    taxCategoryId: item.C_TaxCategory_ID?.id || '',
    SOPOType: item.SOPOType?.identifier || '',
    SOPOTypeId: item.SOPOType?.id || '',
    taxPostingIndicator: item.TaxPostingIndicator?.identifier || '',
    taxPostingIndicatorId: item.TaxPostingIndicator?.id || '',
    taxProvider: item.C_TaxProvider_ID?.identifier || '',
    taxProviderId: item.C_TaxProvider_ID?.id || '',
    organization: item.AD_Org_ID?.identifier || '',
    organizationId: item.AD_Org_ID?.id || ''
  }
}) || []);

const forcingLogout = async () => {
  await $fetch('/api/idempiere-auth/logout', {
    method: 'POST',
    headers: useRequestHeaders(['cookie'])
  })

  tabs.value = [{link: '/', text: 'Home', active: true}]
  localStorage.setItem('tabs', JSON.stringify(tabs.value))

  console.info('Session expired and it will auto redirected toward login page.')
  location.href = '/signin'
}
const alert = ref({
  status: data.value?.status || 200,
  message: data.value?.message || ''
});
onBeforeMount(() => {
  if(Number(data.value?.status || 200) === 401) {
    forcingLogout()
  }
})
watch(data, () => {
  alert.value.status = data.value?.status || 200
  alert.value.message = data.value?.message || ''
  if(Number(data.value?.status || 200) === 401) {
    forcingLogout()
  }
})

const checkboxSelection = (params) => {
  return params.api.getRowGroupColumns().length === 0;
};
const headerCheckboxSelection = (params) => {
  return params.api.getRowGroupColumns().length === 0;
};

const colDefs = ref([
  { 
    width: 50,
    checkboxSelection: checkboxSelection,
    headerCheckboxSelection: headerCheckboxSelection
  },
  { 
    field: 'id',
    //hide: true,
    sort: 'desc'
  },
  { 
    field: 'organization',
    type: 'nonEditableColumn' 
  },
  { field: 'name' },
  { 
    field: 'description',
    headerName: 'Description'
  },
  { field: 'rate' },
  { 
    field: 'isActive',
    headerName: 'Active'
  },
  { 
    field: 'isDefault',
    headerName: 'Default'
  },
  { 
    headerName: 'Action',
    minWidth: 80,
    type: 'nonEditableColumn',
    cellRenderer: TaxRateAction
  }
]);

const cellClick = (event, gridApi) => {
  selectedRows.value = gridApi.getSelectedRows()

  if(event.source === 'checkboxSelected') {
    isDeletable.value = false
    if(selectedRows.value.length >= 1) {
      isDeletable.value = true
    }
  }
}

const cellChange = async (event) => {
  const res = await $fetch('/api/settings/tax-rates/update', {
    method: 'PUT',
    headers: useRequestHeaders(['cookie']),
    body: {
      id: event.data.id,
      name: event.data.name,
      description: event.data.description,
      isActive: event.data.isActive,
      isDefault: event.data.isDefault,
      isDocumentLevel: event.data.isDocumentLevel,
      isSummary: event.data.isSummary,
      isTaxExempt: event.data.isTaxExempt,
      isSalesTax: event.data.isSalesTax,
      validFrom: event.data.validFrom,
      rate: event.data.rate,
      requiresTaxCertificate: event.data.requiresTaxCertificate,
      taxIndicator: event.data.taxIndicator,
    }
  })

  if(Number(res.status) >= 400) {
    alert.value.status = res.status
    alert.value.message = res.message
  }
}

const breadCrumb = computed(() => ([
  { link: '#', text: 'Settings'},
  { link: '/settings/tax-rates', text: 'Tax Rates', active: true}
]))

const create = () => {
  router.push('/settings/tax-rates/create')
}

const destroy = async () => {
  if(selectedRows.value.length >= 1) {
    isDeletable.value = false

    const res = await $fetch('/api/settings/tax-rates/destroy', {
      method: 'DELETE',
      headers: useRequestHeaders(['cookie']),
      body: {
        ids: selectedRows.value.map(i => i.id)
      }
    })

    if(Number(res.status) >= 400) {
      alert.value.status = res.status
      alert.value.message = res.message
    }

    refresh()
  }
}
</script>

<template>
  <Head>
    <Title>Tax Rates</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />
    <div>
      <div class="banner datatable-wrapper">
        <HeaderAction :isDeletable="isDeletable" @create="create" @destroy="destroy" />
        <div>
          <div>
            <AlertBox :alert="alert" />
            <div class="mb-3">
              <AgGrid :entries="rowData" :columns="colDefs" @cellClick="cellClick" @cellChange="cellChange" />
            </div>
          </div>
        </div>
      </div>

    </div>
  </NuxtLayout>
</template>